net.sf.saxon.value

## Class Closure<T extends Item>

- java.lang.Object
- - net.sf.saxon.value.Closure<T>

- All Implemented Interfaces:
    Sequence
  Direct Known Subclasses:
    MemoClosure, SingletonClosure

      public class Closure<T extends Item>
      extends Object
      implements Sequence

  A Closure represents a value that has not yet been evaluated: the value is represented by an expression, together with saved values of all the context variables that the expression depends on.

  This Closure is designed for use when the value is only read once. If the value is read more than once, a new iterator over the underlying expression is obtained each time: this may (for example in the case of a filter expression) involve significant re-calculation.

  The expression may depend on local variables and on the context item; these values are held in the saved XPathContext object that is kept as part of the Closure, and they will always be read from that object. The expression may also depend on global variables; these are unchanging, so they can be read from the Bindery in the normal way. Expressions that depend on other contextual information, for example the values of position(), last(), current(), current-group(), should not be evaluated using this mechanism: they should always be evaluated eagerly. This means that the Closure does not need to keep a copy of these context variables.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `depth`
    `protected Expression` | `expression`
    `protected SequenceIterator<T>` | `inputIterator`
    `protected XPathContextMajor` | `savedXPathContext`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Closure()` Constructor should not be called directly, instances should be made using the make() method.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getCardinality()` Get the cardinality
    `Expression` | `getExpression()`
    `ItemType` | `getItemType(TypeHierarchy th)` Get the static item type
    `XPathContextMajor` | `getSavedXPathContext()`
    `Item` | `head()` Get the first item in the sequence.
    `SequenceIterator<T>` | `iterate()` Evaluate the expression in a given context to return an iterator over a sequence
    `static Sequence` | `make(Expression expression, XPathContext context, int ref)` Construct a Closure by supplying the expression and the set of context variables.
    `void` | `process(XPathContext context)` Process the instruction, without returning any tail calls
    `GroundedValue` | `reduce()` Reduce a value to its simplest form.
    `void` | `saveContext(Expression expression, XPathContext context)`
    `void` | `setExpression(Expression expression)`
    `void` | `setSavedXPathContext(XPathContextMajor savedXPathContext)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### expression

          protected Expression expression

    - #### savedXPathContext

          protected XPathContextMajor savedXPathContext

    - #### depth

          protected int depth

    - #### inputIterator

          protected SequenceIterator<T extends Item> inputIterator

  - ### Constructor Detail

    - #### Closure

          public Closure()

      Constructor should not be called directly, instances should be made using the make() method.

  - ### Method Detail

    - #### make

          public static Sequence make(Expression expression,
                      XPathContext context,
                      int ref)
                               throws XPathException

      Construct a Closure by supplying the expression and the set of context variables.
      Parameters:
        `expression` - the expression to be lazily evaluated
        `context` - the dynamic context of the expression including for example the variables on which it depends
        `ref` - the number of references to the value being lazily evaluated; this affects the kind of Closure that is created
      Returns:
        the Closure, a virtual value that can later be materialized when its content is required
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### saveContext

          public void saveContext(Expression expression,
                         XPathContext context)
                           throws XPathException

      Throws:
        `XPathException`

    - #### head

          public Item head()
                    throws XPathException

      Get the first item in the sequence.
      Specified by:
        `head` in interface `Sequence`
      Returns:
        the first item in the sequence if there is one, or null if the sequence is empty
      Throws:
        `XPathException` - in the situation where the sequence is evaluated lazily, and evaluation of the first item causes a dynamic error.

    - #### getItemType

          public ItemType getItemType(TypeHierarchy th)

      Get the static item type
      Parameters:
        `th` - the type hierarchy cache

    - #### getCardinality

          public int getCardinality()

      Get the cardinality

    - #### getExpression

          public Expression getExpression()

    - #### getSavedXPathContext

          public XPathContextMajor getSavedXPathContext()

    - #### setExpression

          public void setExpression(Expression expression)

    - #### setSavedXPathContext

          public void setSavedXPathContext(XPathContextMajor savedXPathContext)

    - #### iterate

          public SequenceIterator<T> iterate()
                                                   throws XPathException

      Evaluate the expression in a given context to return an iterator over a sequence
      Specified by:
        `iterate` in interface `Sequence`
      Returns:
        an iterator over all the items
      Throws:
        `XPathException` - in the situation where the sequence is evaluated lazily, and constructing an iterator over the items causes a dynamic error.

    - #### process

          public void process(XPathContext context)
                       throws XPathException

      Process the instruction, without returning any tail calls
      Parameters:
        `context` - The dynamic context, giving access to the current node, the current variables, etc.
      Throws:
        `XPathException`

    - #### reduce

          public GroundedValue reduce()
                               throws XPathException

      Reduce a value to its simplest form. If the value is a closure or some other form of deferred value such as a FunctionCallPackage, then it is reduced to a SequenceExtent. If it is a SequenceExtent containing a single item, then it is reduced to that item. One consequence that is exploited by class FilterExpression is that if the value is a singleton numeric value, then the result will be an instance of NumericValue
      Throws:
        `XPathException`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.